
#include <_sio_internal.h>

#ifndef _SIO_MNT_NASDPATH
#define _SIO_MNT_NASDPATH 1
#endif /* _SIO_MNT_NASDPATH */

static pthread_once_t _sio_init_once_block = pthread_once_init;
static int _sio_initted;

struct _sio_mntpoint_list _sio_mntpoint_list;

extern void sio_stdio_init();

void
_sio_init_once()
{
	struct _sio_mntpoint *mnt;

	_sio_exttable_fdescs =
	    _sio_exttable_create(_SIO_EXTTABLE_FILEDESC_UNIQ, SIO_MAX_OPEN);
	_sio_exttable_asynchandles =
	    _sio_exttable_create(_SIO_EXTTABLE_ASYNCHANDLE_UNIQ,
	    SIO_MAX_ASYNC_OUTSTANDING);

	pthread_mutex_init(&_sio_async_io_count_mutex,
	    pthread_mutexattr_default);
	_sio_async_io_count = 0;

	TAILQ_INIT(&_sio_mntpoint_list);

#if _SIO_MNT_NASDPATH > 0
	if ((mnt = _sio_mnt_nasdpath_init("sio-cheops-fs",
	    "/tmp/sio-fs-storage")) != NULL) {
		TAILQ_INSERT_TAIL(&_sio_mntpoint_list, mnt, mnt_link);
	}
#else
	if ((mnt = _sio_mnt_unixpath_init("sio-local-fs",
	    "/glenpinky/sio-fs-storage")) != NULL) {
		TAILQ_INSERT_TAIL(&_sio_mntpoint_list, mnt, mnt_link);
	}

#endif /* _SIO_MNT_NASDPATH */

	sio_stdio_init();
	_sio_initted = 1;
}

void
_sio_init()
{

	pthread_once(&_sio_init_once_block, &_sio_init_once);

	while (!_sio_initted)
		/* loop */;
}
